////////////////////////////////////////////////////////////////////////////////
//:  Ը 
//e-mail: urvanovf@hotmail.ru
//: http://www.dxgames.narod.ru
////////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_GLLISTBOX_H__233BB108_3C37_4E25_979B_F41493C01319__INCLUDED_)
#define AFX_GLLISTBOX_H__233BB108_3C37_4E25_979B_F41493C01319__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "importexport.h"
#include "cgllabel.h"

//#ifdef CGL_EXPORTS
#include <vector>
using std::vector;
typedef  vector<string> STRINGS_VECTOR;
//#endif

typedef void PFNONENDCHOOSE(const string & p_strChoose);

class CGL_API  CGLListBox : public CGLLabel
{
private:
//#ifdef CGL_EXPORTS
	STRINGS_VECTOR m_vctItems;
	unsigned int m_nSelectedItem;
	unsigned int m_nHighlightSelection;
	unsigned int m_nCurrentScrollPosition;
	PFNONENDCHOOSE *m_pfnOnEndChoose;
//#endif
public:
	CGLListBox(GLfloat p_fx,GLfloat p_fy,
	GLfloat p_fWidth,GLfloat p_fHeight,
	const string& p_strText,PFNONENDCHOOSE * p_pfnOnEndChoose=NULL);

	void AddItem(const string& p_strItem);
	string GetSelectedItem(void) ;
	GLint GetSelectedItemIndex(void);
	virtual void OnMouse(GLint p_nButton,GLint p_nState,GLfloat p_fx,GLfloat p_fy);
	virtual void Draw(void);
	virtual void OnSpecialKey(GLint p_nKey,GLint p_nx,GLint p_ny);
	virtual void OnKeyboard(char p_chKey,GLint p_nx,GLint p_ny);
	virtual ~CGLListBox();

};

#endif // !defined(AFX_GLLISTBOX_H__233BB108_3C37_4E25_979B_F41493C01319__INCLUDED_)
