////////////////////////////////////////////////////////////////////////////////
//:  Ը 
//e-mail: urvanovf@hotmail.ru
//: http://www.dxgames.narod.ru
////////////////////////////////////////////////////////////////////////////////

#include "cglstdafx.h"
#include "cgl.h"

#include <iostream>
using namespace std;

// 
void OnRender(void);
void OnSpecialKey(GLint,GLint,GLint);
void OnTimer(GLint value);
void OnEndEdit(const string& p_strEnterText);
void OnChoose(const string& p_strChoose);
	GLfloat alpha=90.0f;
CGLVector3 v(1.0f,0.0f,0.0f);
CGLFrame fr(10);

//       .
void OnButton(void)
{
	cout<<"Button pressed "<<cpputils::GetTimeString();
}

// 
int main(int argc, char *argv[])
{
    try{
	CGL::InitOpenGL("CGL",&argc,argv);

	cout.setf(ios::unitbuf);

	//  .
	CGL::SetRenderProc(OnRender);
	//    
	CGL::SetSpecialKeyProc(OnSpecialKey);
	//     
	CGL::SetTimerProc(OnTimer);


	CGLControl* p=NULL;
	//    " "    OnButton
	//   - .
	//    -(0.0,0.0)
	//  -(1.0,1.0)
	//   ,    
	//  ,   .
	p=new CGLButton(0.25,0.5,0.5,0.2," ",OnButton);

	//    ""    OnButton
	p=new CGLButton(0.25,0.8,0.5,0.2,"",OnButton);


	// .    :)
	string s="   .      3457     .\n     .";


	//    s.
	p=new CGLSlider(0.0,0.25,0.2,0.2,s);

	
	//     s
	p=new CGLTextBox(0.0,0.7,0.2,0.3,s);

	//     "  "     Enter
	// - OnEndEdit.           (  
	//  ). 
	p=new CGLEditBox(0.75,0.0,0.25,0.1,"  :",20,OnEndEdit);

	//      OnChoose b  MyListBox.
	CGLListBox *plb=new CGLListBox(0.75,0.6,0.25,0.4,"My list box",OnChoose);
	//  
	plb->AddItem("first");
	plb->AddItem("second");
	plb->AddItem("The 3");

	//    
	CGL::MainLoop();
    }
    catch(...)
    {
        fprintf(stderr,"A error detected.\n");
    }
	return 0;
}

void OnRender(void)
{
	//    (CGL   , 
	// ,    )
	glTranslatef(0.0f,0.0f,-10.0f);
	CGL::SetPointLight(GL_LIGHT0,CGLVector3(0.0f,2.0f,0.0f),CGLColor(1.0f,1.0f,1.0f));
	glRotatef(-90,0.0f,1.0f,0.0f);
	glRotatef(alpha,0.0f,1.0f,0.0f);
	
	//fr.Draw();
	//glLoadIdentity();
	glTranslatef(0.0,0.0,-5.0);
	glutSolidSphere(1.0,10,10);


}

void OnSpecialKey(GLint p_nKey, GLint p_nx,GLint p_ny)
{
	static float bs=0.0;
	bs+=0.1;
	switch (p_nKey)
	{
	case GLUT_KEY_F1:
		//  F1   
		glClearColor(bs,1.0f,1.0f,1.0f);
		break;
	case 'a':
	case 'A':
		//   ,     
		glClearColor(0.0,0.0,0.0,0.0);
		break;
	}
}

void OnTimer(GLint value)
{
	alpha-=10.1f;
	if (alpha<=0.0f) alpha=360.0f;
}

void OnEndEdit(const string& p_strEnterText)
{
	cout<<"End of typing: "<<p_strEnterText.data()<<"\n";
}


void OnChoose(const string& p_strChoose)
{
	cout<<"Your choose: "<<p_strChoose.data()<<endl;
}
